OPTION DOTNAME
option casemap:none
include win64.inc
include temphls.inc
include user32.inc
includelib user32.lib
include kernel32.inc
includelib kernel32.lib
include ntdll.inc
includelib ntdll.lib
include dsmhelp.inc
includelib dsmhelp.lib
include gdi32.inc
includelib gdi32.lib
OPTION PROLOGUE:rbpFramePrologue
OPTION EPILOGUE:rbpFrameEpilogue
FULL_OPCSIZE equ 32
EF STRUC
	ID		BYTE ?	;21
	VIP		BYTE ?	;20
	VIF		BYTE ?	;19
	AC		BYTE ?	;18
	VM		BYTE ?	;17
	RF		BYTE ?	;16
	NT		BYTE ?	;14
	IOPL	BYTE ?	;13-12
	_OF		BYTE ?	;11
	_DF		BYTE ?	;10
	_IF		BYTE ?	;9
	TF		BYTE ?	;8
	SF		BYTE ?	;7
	ZF		BYTE ?	;6
	AF		BYTE ?	;4
	PF		BYTE ?	;2
	CF		BYTE ?	;0
EF ENDS
x87c struc
	C0	BYTE ?
	C1	BYTE ?
	C2	BYTE ?
	C3	BYTE ?
	dC0	BYTE ?
	dC1	BYTE ?
	dC2	BYTE ?
	dC3	BYTE ?
x87c ends
Features struc
	Note		BYTE ?
	exNote		BYTE ?
	MnemOrd		WORD ?
	FirstOper	BYTE ?
	SecondOper	BYTE ?
	ThirdOper	BYTE ?
	FourthOper	BYTE ?
	FifthOper   BYTE ?
Features ends
Instruction struc
	CodePtr			PVOID ?	;in/out 0
	NextPtr			PVOID ? ;in/out +8
	AlterBase		QWORD ? ;in/out +16
	MnemOperType	LPSTR ? ;out +24
	Mnemonic		LPSTR ? ;out +32
	Oper1Mnemonic	LPSTR ? ;+40
	Oper2Mnemonic	LPSTR ? ;+48
	Oper3Mnemonic	LPSTR ?
	Oper4Mnemonic	LPSTR ?
	Oper5Mnemonic	LPSTR ?
	RemnCode		ULONG64 ? ;in/out
	ModrmOffsets	PVOID ?
	DsmCtrl			DWORD ?
	Mode			BYTE ?  ;in +32
	IsHeapStr		BYTE ?	
	FullOpcode		BYTE FULL_OPCSIZE dup(?)
	;Legacy prefixes
	SegOver			BYTE ? ;out
	RepPfx			BYTE ? ;out
	PfxCnt			BYTE ? ;out
	;REX prefix
	RexPfx			BYTE ? ;out
	InstrLen		BYTE ? ;out
	;ModRM
	mode			BYTE ? ;out
	reg				BYTE ? ;out +40
	rmem			BYTE ? ;out
	;SIB
	Scale			BYTE ? ;out
	Index			BYTE ? ;out
	Base			BYTE ? ;out
	ModRmAddress	BYTE 32 dup(?)
	mOffset			DWORD ? ;out +76
	DefaultOperSize	BYTE ? ;out
	OpFeatures		Features <>
	iFlags			PVOID ?
	x87Condition	x87c <>
	iMxcsr			DWORD ?
	DataSegMnem		DWORD ? ;out +88
	Status			DWORD ?
	AddrBias		DWORD ? ;out
	Opflags			DWORD ? ;out	
	DefaultAddrSize	BYTE ? ;out +96
	RipOffset		BYTE 25 dup(?)
	JAddrOffset		BYTE 25 dup(?)
Instruction ends
HINSTR TYPEDEF PTR Instruction
.const
PEFile2 db 'win64.exe',0
AsmListic db 'asmlist.txt',0
ClassName	db 'win64',0
AppName		db 'DSM',0
edit db 'edit',0
button db 'button',0
lfFont	label LOGFONT
	lfHeight		dd 0
	lfWidth		dd 0
	lfEscapement	dd 0
	lfOrientation	dd 0
	lfWeight		dd FW_NORMAL
	lfItalic		db FALSE
	lfUnderline	db FALSE
	lfStrikeOut	db FALSE
	lfCharSet		db ANSI_CHARSET
	lfOutPrecision	db OUT_DEFAULT_PRECIS
	lfClipPrecision	db CLIP_DEFAULT_PRECIS
	lfQuality		db DEFAULT_QUALITY
	lfPitchAndFamily	db DEFAULT_PITCH
	lfFaceName	db 'Courier',0
TestSplit db 'InSeRtQ 	xmm5	, xmm12	 ',13,10,'rtrwtwerwer',0
TestAddr db 'ss:[r12+4*r12]',0
ULTOSTR MACRO Ulong:REQ,Radix:REQ
LOCAL StrResult,IntChar,Char
	StrResult TEXTEQU <>
	IF Ulong EQ 0
		StrResult TEXTEQU <0>
	ENDIF
	WHILE Ulong NE 0
		IntChar=Ulong-(Ulong/Radix)
		Ulong=(Ulong-IntChar)/Radix
;;		IF IntChar GT 9
;;			Char SUBSTR <abcdefghijklmnopqrstuvwxyz>,(IntChar-9),1
;;		ELSE
;;			Char SUBSTR <0123456789>,(IntChar+1),1
;;		ENDIF
;;		StrResult CATSTR Char,StrResult
	ENDM
	%echo StrResult
ENDM
STRTOUL MACRO String:REQ,Radix:REQ
LOCAL UpperCase,IntResult,IntChar
	UpperCase TEXTEQU ToUpper(String)
	IntResult=0
%	FORC char,UpperCase
		IntResult=IntResult*Radix
		IntChar=@InStr(1,<0123456789>,char)-1
		IF IntChar EQ -1
			IntChar=@InStr(1,<ABCDEFGHIJKLMNOPQRSTUVWXYZ>,char)+9
		ENDIF
		IntResult=IntResult+IntChar
	ENDM
	EXITM @CatStr(%IntResult)
ENDM
mvar1 TEXTEQU STRTOUL(prefetchnta,36)
TstMnem db 'vmread [rax],rdx',0
DefaultMnem db 'lock add qword ptr gs:[edx+8*r15d+$-200000000h],12AADDFFh',0
.data
wcex	label WNDCLASSEX
	cbSize			dd sizeof WNDCLASSEX
	style			dd 0
	lpfnWndProc		dq offset WndProc
	cbClsExtra		dd 0
	cbWndExtra		dd 0
	hInstance		dq 100400000h
	hIcon			dq 10003h
	hCursor			dq 10003h
	hbrBackground	dq COLOR_BACKGROUND
	lpszMenuName	dq 0
	lpszClassName	dq offset ClassName
	hIconSm			dq 10003h
StartAddr dq 200400000h	
.data?
mnem db 256 dup(?)
dmnem db 256 dup(?)

