include dsmdemo.inc
.code
SendOut proc <4> pText:QWORD
	mov pText,rcx
	invoke GetWindowTextLength,hMainEdit
	invoke SendMessage,hMainEdit,EM_SETSEL,rax,rax
	invoke SendMessage,hMainEdit,EM_REPLACESEL,FALSE,pText	
	ret
SendOut endp
WinMain proc <12>
LOCAL msgs:MSG
;	call breakpoint
;;	invoke DasmTest,addr trb,1999
;	invoke AsmTest,addr dmnem,addr TstMnem
;	.if eax
;		invoke MessageBox,0,addr dmnem,0,0
;	.endif
;	invoke AsmTest,addr dmnem,addr TstMnem
;	.if eax
;		invoke MessageBox,0,addr dmnem,0,0
;	.endif
;	invoke AsmTest,addr dmnem,addr TstMnem
;	.if eax
;		invoke MessageBox,0,addr dmnem,0,0
;	.endif
;	invoke AsmTest,addr dmnem,addr TstMnem
;	.if eax
;		invoke MessageBox,0,addr dmnem,0,0
;	.endif
	invoke RegisterClassEx, addr wcex
	mov r10,CW_USEDEFAULT
	invoke CreateWindowEx,rbx,addr ClassName,addr AppName,WS_OVERLAPPEDWINDOW or WS_VISIBLE,r10,r10,r10,r10,rbx,rbx,hInstance,rbx
	lea rdi,msgs
	.while TRUE
		invoke GetMessage,rdi,rbx,rbx,rbx
		.break .if ~rax
		invoke TranslateMessage,rdi
		invoke DispatchMessage,rdi
	.endw
	mov rax,[rdi][MSG.wParam]
	invoke ExitProcess,rax
WinMain endp

WndProc proc <12> hWnd:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
RESERV hWin dq ?
RESERV hShowList16 dq ?
RESERV hShowList32 dq ?
RESERV hShowList64 dq ?
RESERV hEdit16 dq ?
RESERV hEdit32 dq ?
RESERV hEdit64 dq ?
RESERV hMainEdit dq ?
RESERV hAssemble dq ?
RESERV hMnemEdit dq ?
RESERV hFont dq ?
RESERV rects RECT {}
RESERV FileName db MAX_PATH dup(?)
CONSTANT Listing db 'Disassemble',0
CONSTANT Life db 'LIFE.COM',0
CONSTANT Win32 db 'win.exe',0
CONSTANT Win64 db 'win64.exe',0
CONSTANT Assembling db 'Assemble',0
;CONSTANT 
	.if edx==WM_COMMAND
		.if r9==hShowList16
			invoke GetWindowText,hEdit16,addr FileName,sizeof FileName
			invoke DasmDosCom,addr FileName,addr AsmListic
			invoke ShowPart,hMainEdit,addr AsmListic
		.elseif r9==hShowList32
			invoke GetWindowText,hEdit32,addr FileName,sizeof FileName
			invoke DasmPE32,addr FileName,addr AsmListic
			invoke ShowPart,hMainEdit,addr AsmListic		
		.elseif r9==hShowList64
			invoke GetWindowText,hEdit64,addr FileName,sizeof FileName
			invoke DasmPE32Plus,addr FileName,addr AsmListic
			invoke ShowPart,hMainEdit,addr AsmListic
		.elseif r9==hAssemble
			invoke GetWindowText,hMnemEdit,addr mnem,sizeof mnem
			invoke AsmTest,addr dmnem,addr mnem
			invoke SendOut,addr dmnem
		.endif
	.elseif edx==WM_SHOWWINDOW
		mov hWin,rcx
		invoke CreateWindowEx,0,addr button,addr Listing,WS_VISIBLE or WS_CHILD,30,15,130,25,hWin,0,hInstance,0
		mov hShowList16,rax
		invoke CreateWindowEx,0,addr button,addr Listing,WS_VISIBLE or WS_CHILD,30,45,130,25,hWin,0,hInstance,0
		mov hShowList32,rax
		invoke CreateWindowEx,0,addr button,addr Listing,WS_VISIBLE or WS_CHILD,30,75,130,25,hWin,0,hInstance,0
		mov hShowList64,rax
		invoke CreateWindowEx,0,addr button,addr Assembling,WS_VISIBLE or WS_CHILD,30,105,130,25,hWin,0,hInstance,0
		mov hAssemble,rax
		invoke CreateWindowEx,0,addr edit,addr Life,WS_VISIBLE or WS_TABSTOP or WS_CHILD or ES_LEFT,\
		165,15,700,25,hWin,0,hInstance,0
		mov hEdit16,rax
		invoke CreateWindowEx,0,addr edit,addr Win32,WS_VISIBLE or WS_TABSTOP or WS_CHILD or ES_LEFT,\
		165,45,700,25,hWin,0,hInstance,0
		mov hEdit32,rax
		invoke CreateWindowEx,0,addr edit,addr Win64,WS_VISIBLE or WS_TABSTOP or WS_CHILD or ES_LEFT,\
		165,75,700,25,hWin,0,hInstance,0
		mov hEdit64,rax
		invoke CreateWindowEx,0,addr edit,addr DefaultMnem,WS_VISIBLE or WS_TABSTOP or WS_CHILD or ES_LEFT,\
		165,105,700,25,hWin,0,hInstance,0
		mov hMnemEdit,rax
		invoke CreateWindowEx,0,addr edit,0,WS_VISIBLE or WS_TABSTOP or WS_CHILD or ES_LEFT or WS_HSCROLL or WS_VSCROLL or ES_MULTILINE,\
		30,60,900,450,hWin,0,hInstance,0
		mov hMainEdit,rax
		invoke GetClientRect,hWin,addr rects
		sub rects.bottom,150
		mov r10d,rects.bottom
		mov r9d,rects.right
		mov edx,rects.left
		invoke MoveWindow,hMainEdit,rdx,60,r9,r10,TRUE
		invoke CreateFontIndirect,addr lfFont
		mov hFont,rax
		invoke SendMessage,hMainEdit,WM_SETFONT,rax,TRUE
	.elseif edx==WM_SIZE
		invoke GetClientRect,hWin,addr rects
		sub rects.bottom,150
		mov r10d,rects.bottom
		mov r9d,rects.right
		mov edx,rects.left
		invoke MoveWindow,hMainEdit,rdx,150,r9,r10,TRUE
	.elseif edx==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else
		leave
		jmp DefWindowProc
	.endif
	xor rax,rax
	ret
WndProc endp
DasmDosCom proc uses rbx rsi ComName:PVOID,AsmListing:PVOID
LOCAL hCom:HANDLE,hLst:HANDLE,Code16:PVOID,cRW:QWORD,Instruc:HINSTR
LOCAL ComSize:DWORD,ListSize:DWORD
LOCAL MnemLen:ULONG,InstrLen:ULONG
LOCAL SizeMnems:ULONG,SizeInstrs:ULONG
LOCAL Mnemonic[256]:BYTE
	and SizeMnems,NULL
	and SizeInstrs,NULL
	mov ComName,rcx
	mov AsmListing,rdx
	invoke CreateFile,rcx,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ,0,OPEN_EXISTING,0,0
	mov hCom,rax
	invoke CreateFile,AsmListing,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ,0,CREATE_ALWAYS,0,0
	mov hLst,rax
	invoke GetFileSize,hCom,NULL
	mov ComSize,eax
	or eax,eax
	invoke VirtualAlloc,NULL,rax,MEM_COMMIT,PAGE_EXECUTE_READWRITE
	mov Code16,rax
	mov r8d,ComSize
	invoke ReadFile,hCom,rax,r8,addr cRW,NULL
	mov r9d,ComSize
	invoke InitInstr,Code16,100h,LEGACY_MODE16,r9
	mov Instruc,rax
	.while TRUE
		invoke Disassemble,Instruc,addr Mnemonic,addr MnemLen,STD_MNEM
		mov r8d,MnemLen
		.break .if ~r8d
		invoke WriteFile,hLst,addr Mnemonic,r8,addr cRW,NULL
	.endw
	invoke FreeInstr,Instruc
	mov edx,ComSize
	invoke VirtualFree,Code16,rdx,MEM_DECOMMIT
	invoke CloseHandle,hCom
	invoke CloseHandle,hLst
	ret
DasmDosCom endp
DasmPE32Plus proc uses rbx rsi ComName:PVOID,AsmListing:PVOID
LOCAL hPe32Plus:HANDLE,hLst:HANDLE,Code64:PVOID,cRW:QWORD,Instruc:HINSTR,Header:PVOID
LOCAL Pe32Size:DWORD,ListSize:DWORD
LOCAL MnemLen:ULONG,InstrLen:ULONG
LOCAL SizeMnems:ULONG,SizeInstrs:ULONG,SizeOfCode:DWORD,Entry:DWORD
LOCAL Mnemonic[256]:BYTE
	and SizeMnems,NULL
	and SizeInstrs,NULL
	mov ComName,rcx
	mov AsmListing,rdx
	invoke CreateFile,rcx,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,0,0
	mov hPe32Plus,rax
	invoke CreateFile,AsmListing,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ,0,CREATE_ALWAYS,0,0
	mov hLst,rax
	invoke GetFileSize,hPe32Plus,NULL
	mov Pe32Size,eax
	invoke VirtualAlloc,NULL,rax,MEM_COMMIT,PAGE_EXECUTE_READWRITE
	mov Code64,rax
	mov r8d,Pe32Size
	invoke ReadFile,hPe32Plus,rax,r8,addr cRW,NULL
	invoke RtlImageNtHeader,Code64
	test rax,rax
	jz NotAPe
	cmp [rax][IMAGE_NT_HEADERS.FileHeader.Machine],8664h
	jnz ItIsPe32
	mov Header,rax
	mov r8d,[rax][IMAGE_NT_HEADERS.OptionalHeader.AddressOfEntryPoint]
	mov Entry,r8d
	invoke RtlImageRvaToSection,rax,Code64,r8	;    
	mov edx,[rax][IMAGE_SECTION_HEADER.VirtualAddress]
	sub edx,Entry
	add edx,[rax][IMAGE_SECTION_HEADER.SizeOfRawData]
	mov SizeOfCode,edx
	mov r8d,Entry
	invoke RtlImageRvaToVa,Header,Code64,r8,NULL
	mov edx,Entry
	mov r10,Header
	add rdx,[r10][IMAGE_NT_HEADERS.OptionalHeader.ImageBase]
	mov r9d,SizeOfCode
	invoke InitInstr,rax,rdx,LONG_MODE,r9
	mov Instruc,rax
	.while TRUE
		invoke Disassemble,Instruc,addr Mnemonic,addr MnemLen,STD_MNEM
		mov r8d,MnemLen
		.break .if ~r8d
		invoke WriteFile,hLst,addr Mnemonic,r8,addr cRW,NULL
	.endw
	invoke FreeInstr,Instruc
	mov edx,Pe32Size
	invoke VirtualFree,Code64,rdx,MEM_DECOMMIT
	invoke CloseHandle,hPe32Plus
	invoke CloseHandle,hLst
	ret
NotAPe:
	CONSTANT NotPE db '  PE32+ .',0
	invoke MessageBox,0,addr NotPE,0,0
	ret
ItIsPe32:
	CONSTANT ItPE32 db '    AMD64/EM64T.',0
	invoke MessageBox,0,addr ItPE32,0,0
	ret
DasmPE32Plus endp
DasmPE32 proc uses rbx rsi ComName:PVOID,AsmListing:PVOID
LOCAL hPe32Plus:HANDLE,hLst:HANDLE,Code64:PVOID,cRW:QWORD,Instruc:HINSTR,Header:PVOID,hMap:HANDLE
LOCAL Pe32Size:DWORD,ListSize:DWORD
LOCAL MnemLen:ULONG,InstrLen:ULONG
LOCAL SizeMnems:ULONG,SizeInstrs:ULONG,SizeOfCode:DWORD,Entry:DWORD
LOCAL Mnemonic[256]:BYTE
	and SizeMnems,NULL
	and SizeInstrs,NULL
	mov ComName,rcx
	mov AsmListing,rdx
	invoke CreateFile,rcx,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,0,0
	mov hPe32Plus,rax
	invoke CreateFile,AsmListing,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ,0,CREATE_ALWAYS,0,0
	mov hLst,rax
	invoke GetFileSize,hPe32Plus,NULL
	mov Pe32Size,eax
	mov edx,eax
	invoke CreateFileMapping,hPe32Plus,NULL,PAGE_READONLY,NULL,NULL,NULL
	mov hMap,rax
	.if ~rax
		invoke MessageBox,hWin,0,0,0
		ret
	.endif
	invoke MapViewOfFile,hMap,FILE_MAP_READ,NULL,NULL,Pe32Size
	.if ~rax
		invoke MessageBox,hWin,0,0,0
		ret
	.endif
	;invoke VirtualAlloc,NULL,rdx,MEM_COMMIT or MEM_RESERVE or MEM_TOP_DOWN,PAGE_EXECUTE_READWRITE
	mov Code64,rax
	mov r8d,Pe32Size
	invoke ReadFile,hPe32Plus,rax,r8,addr cRW,NULL
	invoke RtlImageNtHeader,Code64
	or rax,rax
	jz NotAPe
	cmp [rax][IMAGE_NT_HEADERS.FileHeader.Machine],8664h
	jz ItIsPe32Plus
	mov Header,rax
	mov r8d,[rax][IMAGE_NT_HEADERS.OptionalHeader.AddressOfEntryPoint]
	mov Entry,r8d
	invoke RtlImageRvaToSection,rax,Code64,r8	;    
	mov edx,[rax][IMAGE_SECTION_HEADER.VirtualAddress]
	sub edx,Entry
	add edx,[rax][IMAGE_SECTION_HEADER.SizeOfRawData]
	mov SizeOfCode,edx
	mov r8d,Entry
	invoke RtlImageRvaToVa,Header,Code64,r8,NULL
	mov edx,Entry
	mov r10,Header
	add edx,[r10][IMAGE_NT_HEADERS32.OptionalHeader.ImageBase]
	mov r9d,SizeOfCode
	invoke InitInstr,rax,rdx,LEGACY_MODE32,r9
	mov Instruc,rax
	.while TRUE
		invoke Disassemble,Instruc,addr Mnemonic,addr MnemLen,STD_MNEM
		mov r8d,MnemLen
		add SizeMnems,eax
		.break .if ~r8d
		invoke WriteFile,hLst,addr Mnemonic,r8,addr cRW,NULL
		;invoke MessageBox,hWin,addr Mnemonic,0,0
	.endw
	invoke FreeInstr,Instruc
	mov edx,Pe32Size
	invoke UnmapViewOfFile,Code64
	invoke CloseHandle,hMap
	;invoke VirtualFree,Code64,rdx,MEM_DECOMMIT
	invoke CloseHandle,hPe32Plus
	invoke CloseHandle,hLst
	ret
NotAPe:
	invoke MessageBox,hWin,addr NotPE,0,0
	ret
ItIsPe32Plus:
	CONSTANT ItPE32Plus db '   AMD64/EM64T.',0
	invoke MessageBox,hWin,addr ItPE32Plus,0,0
	ret
DasmPE32 endp
ShowPart proc <7> hEdit:HANDLE,AsmListing:PVOID
LOCAL hLst:HANDLE,lstSize:QWORD,pmem:PVOID,cRW:QWORD
	mov hEdit,rcx
	invoke CreateFile,rdx,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ,0,OPEN_EXISTING,0,0
	mov hLst,rax
	invoke GetFileSize,rax,NULL
	mov rdx,32 shl 10
	cmp rax,rdx
	cmova rax,rdx
	mov lstSize,rax
	add rax,4 shl 10
	invoke VirtualAlloc,NULL,rax,MEM_COMMIT,PAGE_EXECUTE_READWRITE
	mov pmem,rax
	invoke ReadFile,hLst,pmem,lstSize,addr cRW,NULL
	invoke SetWindowText,hEdit,pmem
	add lstSize,4 shl 10
	invoke VirtualFree,pmem,lstSize,MEM_DECOMMIT
	invoke CloseHandle,hLst
	ret
ShowPart endp
breakpoint proc uses rcx rax rdx r8 r9 r10 r11
	call IsDebuggerPresent
	.if eax
		int 3
	.endif
	ret
breakpoint endp
AsmTest proc dMnemonic:PVOID,Mnemonic:PVOID
LOCAL hInstr:HINSTR
LOCAL AsmDasm[16]:BYTE,ilen:ULONG64
CONSTANT Error db 'Bad mnemonic',0
	mov dMnemonic,rcx
	mov Mnemonic,rdx
	invoke InitInstr,addr AsmDasm,StartAddr,LONG_MODE,sizeof AsmDasm
	mov hInstr,rax
	invoke Assemble,hInstr,Mnemonic
	mov ilen,rax
	.if ~eax || eax==-1
		invoke MessageBox,hWin,addr Error,0,MB_OK
		xor eax,eax
		ret
	.endif
	invoke JoinMnemonic,hInstr,dMnemonic,NULL,STD_MNEM
	mov rax,hInstr
	movzx rax,[rax][Instruction.InstrLen]
	mov rax,ilen
	add StartAddr,rax
	invoke FreeInstr,hInstr
	mov eax,TRUE
	ret
AsmTest endp
DasmTest proc <4> pCode:PVOID,cSize:DWORD
LOCAL hInstr:HINSTR	
LOCAL adMnemonic[256]:BYTE
	mov r9,rdx
	invoke InitInstr,rcx,rcx,0,r9
	mov hInstr,rax
	invoke Disassemble,HINSTR,addr adMnemonic,NULL,STD_MNEM
	invoke MessageBox,0,addr adMnemonic,0,0
	invoke Disassemble,HINSTR,addr adMnemonic,NULL,STD_MNEM
	invoke MessageBox,0,addr adMnemonic,0,0
	invoke FreeInstr,HINSTR
	ret
DasmTest endp
end